xref: /xnu-10002.41.9/tools/remote_build.sh (revision 699cd48037512bf4380799317ca44ca453c82f57)
1*699cd480SApple OSS Distributions#!/bin/bash
2*699cd480SApple OSS Distributions#
3*699cd480SApple OSS Distributions# Script that rsyncs a source/build tree to a remote server, performs a build,
4*699cd480SApple OSS Distributions# and copies the result back
5*699cd480SApple OSS Distributions#
6*699cd480SApple OSS Distributions
7*699cd480SApple OSS Distributions# This script is invoked instead of the initial recursive make(1) in ./Makefile.
8*699cd480SApple OSS Distributions# First it must cache all binaries that might be used during the build by
9*699cd480SApple OSS Distributions# calling "make print_exports" (any target would work) with an overriden xcrun(1)
10*699cd480SApple OSS Distributions# which caches tools an SDKs into ./BUILD/obj/BuildTools. When the combined
11*699cd480SApple OSS Distributions# source+build tree is rsync-ed to the remote server, we run a script to
12*699cd480SApple OSS Distributions# re-initiate the build using an overriden xcrun(1) which hands back
13*699cd480SApple OSS Distributions# cached tools in ./BUILD/obj/BuildTools instead of whatever Xcode tools are on
14*699cd480SApple OSS Distributions# the remote system (or if no Xcode tools are installed remotely). Finally,
15*699cd480SApple OSS Distributions# the build results are copied back locally.
16*699cd480SApple OSS Distributions#
17*699cd480SApple OSS Distributions
18*699cd480SApple OSS Distributionsfunction die() {
19*699cd480SApple OSS Distributions    echo "$1" 1>&2
20*699cd480SApple OSS Distributions    exit 1
21*699cd480SApple OSS Distributions}
22*699cd480SApple OSS Distributions
23*699cd480SApple OSS Distributions
24*699cd480SApple OSS DistributionsTARGET=
25*699cd480SApple OSS Distributionsdeclare -a ARGS
26*699cd480SApple OSS Distributionsdeclare -a REMOTEARGS
27*699cd480SApple OSS Distributionsindex=0
28*699cd480SApple OSS Distributionsfor arg in "$@"; do
29*699cd480SApple OSS Distributions    case $arg in
30*699cd480SApple OSS Distributions	_REMOTEBUILD_TARGET=*)
31*699cd480SApple OSS Distributions	    TARGET=`echo $arg | awk -F= '{print $2}'`
32*699cd480SApple OSS Distributions	    continue
33*699cd480SApple OSS Distributions	    ;;
34*699cd480SApple OSS Distributions	_REMOTEBUILD_MAKE=*)
35*699cd480SApple OSS Distributions	    MAKE=`echo $arg | awk -F= '{print $2}'`
36*699cd480SApple OSS Distributions	    continue
37*699cd480SApple OSS Distributions	    ;;
38*699cd480SApple OSS Distributions	REMOTEBUILD=*)
39*699cd480SApple OSS Distributions	    # Don't restart another remote build remotely
40*699cd480SApple OSS Distributions	    ;;
41*699cd480SApple OSS Distributions	SRCROOT=*)
42*699cd480SApple OSS Distributions	    continue
43*699cd480SApple OSS Distributions	    ;;
44*699cd480SApple OSS Distributions	OBJROOT=*)
45*699cd480SApple OSS Distributions	    continue
46*699cd480SApple OSS Distributions	    ;;
47*699cd480SApple OSS Distributions	SYMROOT=*)
48*699cd480SApple OSS Distributions	    continue
49*699cd480SApple OSS Distributions	    ;;
50*699cd480SApple OSS Distributions	DSTROOT=*)
51*699cd480SApple OSS Distributions	    continue
52*699cd480SApple OSS Distributions	    ;;
53*699cd480SApple OSS Distributions	CCHROOT=*)
54*699cd480SApple OSS Distributions	    continue
55*699cd480SApple OSS Distributions	    ;;
56*699cd480SApple OSS Distributions	RC_XBS=*)
57*699cd480SApple OSS Distributions	    # Remote build isn't chrooted or special in any way
58*699cd480SApple OSS Distributions	    arg="VERBOSE=YES"
59*699cd480SApple OSS Distributions	    continue
60*699cd480SApple OSS Distributions	    ;;
61*699cd480SApple OSS Distributions	VERBOSE=YES)
62*699cd480SApple OSS Distributions	    set -x
63*699cd480SApple OSS Distributions	    ;;
64*699cd480SApple OSS Distributions    esac
65*699cd480SApple OSS Distributions    ARGS[$index]="$arg"
66*699cd480SApple OSS Distributions    REMOTEARGS[$index]="\"$arg\""
67*699cd480SApple OSS Distributions    index=$(($index+1))
68*699cd480SApple OSS Distributionsdone
69*699cd480SApple OSS Distributions
70*699cd480SApple OSS Distributions
71*699cd480SApple OSS DistributionsRSYNC_ARGS="-azvh"
72*699cd480SApple OSS DistributionsARGS[$index]="REMOTEBUILD="
73*699cd480SApple OSS DistributionsREMOTEARGS[$index]="\"REMOTEBUILD=\""
74*699cd480SApple OSS Distributions
75*699cd480SApple OSS Distributions# For some targets like installsrc, we can't to a remote build
76*699cd480SApple OSS DistributionsSKIPREMOTE=0
77*699cd480SApple OSS Distributionscase $TARGET in
78*699cd480SApple OSS Distributions    clean)
79*699cd480SApple OSS Distributions	SKIPREMOTE=1
80*699cd480SApple OSS Distributions	;;
81*699cd480SApple OSS Distributions    installsrc)
82*699cd480SApple OSS Distributions	SKIPREMOTE=1
83*699cd480SApple OSS Distributions	;;
84*699cd480SApple OSS Distributions    installopensource)
85*699cd480SApple OSS Distributions	SKIPREMOTE=1
86*699cd480SApple OSS Distributions	;;
87*699cd480SApple OSS Distributions    cscope)
88*699cd480SApple OSS Distributions	SKIPREMOTE=1
89*699cd480SApple OSS Distributions	;;
90*699cd480SApple OSS Distributions    tags)
91*699cd480SApple OSS Distributions	SKIPREMOTE=1
92*699cd480SApple OSS Distributions	;;
93*699cd480SApple OSS Distributions    help)
94*699cd480SApple OSS Distributions	SKIPREMOTE=1
95*699cd480SApple OSS Distributions	;;
96*699cd480SApple OSS Distributionsesac
97*699cd480SApple OSS Distributions
98*699cd480SApple OSS Distributionsif [ $SKIPREMOTE -eq 1 ]; then
99*699cd480SApple OSS Distributions    exec "$MAKE" "$TARGET" "${ARGS[@]}"
100*699cd480SApple OSS Distributionsfi
101*699cd480SApple OSS Distributions
102*699cd480SApple OSS DistributionsSRC="$(pwd -P)"
103*699cd480SApple OSS DistributionsSRCNAME="$(basename $SRC)"
104*699cd480SApple OSS Distributions
105*699cd480SApple OSS Distributions# Pick up build locations passed in the environment
106*699cd480SApple OSS DistributionsOBJROOT="${OBJROOT}"
107*699cd480SApple OSS DistributionsSYMROOT="${SYMROOT}"
108*699cd480SApple OSS DistributionsDSTROOT="${DSTROOT}"
109*699cd480SApple OSS Distributions
110*699cd480SApple OSS Distributionsif [ -z "${OBJROOT}" ]; then
111*699cd480SApple OSS Distributions    die "OBJROOT not set in environment"
112*699cd480SApple OSS Distributionsfi
113*699cd480SApple OSS Distributionsmkdir -p "${OBJROOT}" || die "Could not create ${OBJROOT}"
114*699cd480SApple OSS Distributions
115*699cd480SApple OSS Distributionsif [ -z "${SYMROOT}" ]; then
116*699cd480SApple OSS Distributions    die "SYMROOT not set in environment"
117*699cd480SApple OSS Distributionsfi
118*699cd480SApple OSS Distributionsmkdir -p "${SYMROOT}" || die "Could not create ${SYMROOT}"
119*699cd480SApple OSS Distributions
120*699cd480SApple OSS Distributionsif [ -z "${DSTROOT}" ]; then
121*699cd480SApple OSS Distributions    die "DSTROOT not set in environment"
122*699cd480SApple OSS Distributionsfi
123*699cd480SApple OSS Distributionsmkdir -p "${DSTROOT}" || die "Could not create ${DSTROOT}"
124*699cd480SApple OSS Distributions
125*699cd480SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
126*699cd480SApple OSS Distributions    :
127*699cd480SApple OSS Distributionselse
128*699cd480SApple OSS Distributions    DOINSTALLSRC=0
129*699cd480SApple OSS Distributions    REMOTE_SRCREL="./"
130*699cd480SApple OSS Distributions    BUILDTOOLSDIR="$OBJROOT"
131*699cd480SApple OSS Distributions    REMOTE_BUILDTOOLSREL="./BUILD/obj"
132*699cd480SApple OSS Distributions    BUILDSCRIPTDIR="$OBJROOT"
133*699cd480SApple OSS Distributions    REMOTE_BUILDSCRIPTREL="./BUILD/obj"
134*699cd480SApple OSS Distributions    BUILDSCRIPTNAME="build.sh"
135*699cd480SApple OSS Distributions    if [ ! -d "${OBJROOT}/SETUP" ]; then
136*699cd480SApple OSS Distributions    RSYNC_DELETE_EXCLUDED="--delete-excluded"
137*699cd480SApple OSS Distributions    else
138*699cd480SApple OSS Distributions    RSYNC_DELETE_EXCLUDED=""
139*699cd480SApple OSS Distributions    fi
140*699cd480SApple OSS Distributions    if [ ! -e "${SYMROOT}/" ]; then
141*699cd480SApple OSS Distributions	RSYNC_DELETE_SYMROOT=1
142*699cd480SApple OSS Distributions    else
143*699cd480SApple OSS Distributions	RSYNC_DELETE_SYMROOT=0
144*699cd480SApple OSS Distributions    fi
145*699cd480SApple OSS Distributions    if [ ! -e "${DSTROOT}/" ]; then
146*699cd480SApple OSS Distributions	RSYNC_DELETE_DSTROOT=1
147*699cd480SApple OSS Distributions    else
148*699cd480SApple OSS Distributions	RSYNC_DELETE_DSTROOT=0
149*699cd480SApple OSS Distributions    fi
150*699cd480SApple OSS Distributions    TARBUILDDIRS=0
151*699cd480SApple OSS Distributionsfi
152*699cd480SApple OSS Distributions
153*699cd480SApple OSS Distributionsecho "Caching build tools..." 1>&2
154*699cd480SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}" || die "Could not create BUILDTOOLSDIR"
155*699cd480SApple OSS Distributions$MAKE print_exports "${ARGS[@]}" XCRUN="${SRC}/tools/xcrun_cache.sh -c \"${BUILDTOOLSDIR}\"" >/dev/null || die "Could not cache build tools"
156*699cd480SApple OSS Distributions
157*699cd480SApple OSS Distributions# Cache the make(1) binary itself
158*699cd480SApple OSS DistributionsMAKE_SDKROOT=`"${SRC}/tools/xcrun_cache.sh" -u "${BUILDTOOLSDIR}" -sdk / -show-sdk-path`
159*699cd480SApple OSS Distributions"${SRC}/tools/xcrun_cache.sh" -c "${BUILDTOOLSDIR}" -sdk "${MAKE_SDKROOT}" -find make >/dev/null || die "Could not cache make"
160*699cd480SApple OSS Distributions
161*699cd480SApple OSS Distributions# Create a canned build script that can restart the build on the remote server.
162*699cd480SApple OSS Distributionsmkdir -p "${BUILDSCRIPTDIR}" || die "Could not create BUILDSCRIPTDIR"
163*699cd480SApple OSS Distributionscat > "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}" <<EOF
164*699cd480SApple OSS Distributions#!/bin/sh
165*699cd480SApple OSS Distributionsmkdir -p /private/tmp
166*699cd480SApple OSS Distributionsmkdir -p /private/var/tmp
167*699cd480SApple OSS Distributionsmkdir -p "\${TMPDIR}"
168*699cd480SApple OSS Distributionscd "${REMOTE_SRCREL}"
169*699cd480SApple OSS Distributionsmkdir -p ./BUILD/obj
170*699cd480SApple OSS Distributionsmkdir -p ./BUILD/sym
171*699cd480SApple OSS Distributionsmkdir -p ./BUILD/dst
172*699cd480SApple OSS DistributionsMAKE=\`\$PWD/tools/xcrun_cache.sh -u "\$PWD/${REMOTE_BUILDTOOLSREL}" -sdk / -find make\`
173*699cd480SApple OSS Distributionsif [ -z "\${MAKE}" ]; then exit 1; fi
174*699cd480SApple OSS Distributions\${MAKE} ${TARGET} ${REMOTEARGS[@]} XCRUN="\$PWD/tools/xcrun_cache.sh -u \"\$PWD/${REMOTE_BUILDTOOLSREL}\""
175*699cd480SApple OSS Distributionsret=\$?
176*699cd480SApple OSS Distributionsif [ \$ret -eq 0 ]; then
177*699cd480SApple OSS Distributionsif [ ${TARBUILDDIRS} -eq 1 ]; then
178*699cd480SApple OSS Distributionstar jcf ./BUILD/obj.tar.bz2 --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf --exclude=conf -C ./BUILD/obj . || exit 1
179*699cd480SApple OSS Distributionstar jcf ./BUILD/sym.tar.bz2 -C ./BUILD/sym . || exit 1
180*699cd480SApple OSS Distributionstar jcf ./BUILD/dst.tar.bz2 -C ./BUILD/dst . || exit 1
181*699cd480SApple OSS Distributionsfi
182*699cd480SApple OSS Distributionsfi
183*699cd480SApple OSS Distributionsexit \$ret
184*699cd480SApple OSS DistributionsEOF
185*699cd480SApple OSS Distributionschmod a+x "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
186*699cd480SApple OSS Distributions#echo "Build script is:"
187*699cd480SApple OSS Distributions#cat "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
188*699cd480SApple OSS Distributions
189*699cd480SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}/empty"
190*699cd480SApple OSS Distributions
191*699cd480SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
192*699cd480SApple OSS Distributions    :
193*699cd480SApple OSS Distributionselse
194*699cd480SApple OSS Distributions
195*699cd480SApple OSS Distributions    REMOTEBUILD="$REMOTEBUILD"
196*699cd480SApple OSS Distributions    REMOTEBUILDPATH="$REMOTEBUILDPATH"
197*699cd480SApple OSS Distributions
198*699cd480SApple OSS Distributions    if [ -z "$REMOTEBUILDPATH" ]; then
199*699cd480SApple OSS Distributions	WHOAMI=`whoami`
200*699cd480SApple OSS Distributions	case "${REMOTEBUILD}" in
201*699cd480SApple OSS Distributions	    *@*)
202*699cd480SApple OSS Distributions		WHOAMI=`echo "${REMOTEBUILD}" | awk -F@ '{print $1}'`
203*699cd480SApple OSS Distributions		;;
204*699cd480SApple OSS Distributions	esac
205*699cd480SApple OSS Distributions	REMOTEBUILDPATH="/tmp/$WHOAMI"
206*699cd480SApple OSS Distributions    fi
207*699cd480SApple OSS Distributions
208*699cd480SApple OSS Distributions# Construct a unique remote path
209*699cd480SApple OSS Distributions    eval `stat -s "${SRC}"`
210*699cd480SApple OSS Distributions
211*699cd480SApple OSS Distributions    REMOTEBUILDPATH="${REMOTEBUILDPATH}/$st_ino/${SRCNAME}/"
212*699cd480SApple OSS Distributions    echo "Remote path is ${REMOTEBUILD}:${REMOTEBUILDPATH}" 1>&2
213*699cd480SApple OSS Distributions
214*699cd480SApple OSS Distributions    ssh $REMOTEBUILD "mkdir -p \"${REMOTEBUILDPATH}/BUILD/\"{obj,sym,dst}" || die "Could not make remote build directory"
215*699cd480SApple OSS Distributions
216*699cd480SApple OSS Distributions    # Copy source only
217*699cd480SApple OSS Distributions    rsync $RSYNC_ARGS --delete --exclude=\*~ --exclude=.svn --exclude=.git --exclude=/BUILD . $REMOTEBUILD:"${REMOTEBUILDPATH}" || die "Could not rsync source tree"
218*699cd480SApple OSS Distributions
219*699cd480SApple OSS Distributions    # Copy partial OBJROOT (just build tools and build script), and optionally delete everything else
220*699cd480SApple OSS Distributions    rsync $RSYNC_ARGS --delete $RSYNC_DELETE_EXCLUDED --include=/build.sh --include=/BuildTools --include=/BuildTools/\*\* --exclude=\* "${OBJROOT}/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" || die "Could not rsync build tree"
221*699cd480SApple OSS Distributions
222*699cd480SApple OSS Distributions    # Delete remote SYMROOT if it has been deleted locally
223*699cd480SApple OSS Distributions    if [ "$RSYNC_DELETE_SYMROOT" -eq 1 ]; then
224*699cd480SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" || die "Could not rsync delete SYMROOT"
225*699cd480SApple OSS Distributions    fi
226*699cd480SApple OSS Distributions
227*699cd480SApple OSS Distributions    # Delete remote DSTROOT if it has been deleted locally
228*699cd480SApple OSS Distributions    if [ "$RSYNC_DELETE_DSTROOT" -eq 1 ]; then
229*699cd480SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" || die "Could not rsync delete DSTROOT"
230*699cd480SApple OSS Distributions    fi
231*699cd480SApple OSS Distributions
232*699cd480SApple OSS Distributions    # Start the build
233*699cd480SApple OSS Distributions    echo ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" 1>&2
234*699cd480SApple OSS Distributions    ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" || die "Could not complete remote build"
235*699cd480SApple OSS Distributions
236*699cd480SApple OSS Distributions    # Copy back build results except for object files (which might be several GB)
237*699cd480SApple OSS Distributions    echo "Copying results back..."
238*699cd480SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" "${OBJROOT}/" || die "Could not rsync build results"
239*699cd480SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" "${SYMROOT}/" || die "Could not rsync build results"
240*699cd480SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" "${DSTROOT}/" || die "Could not rsync build results"
241*699cd480SApple OSS Distributions
242*699cd480SApple OSS Distributionsfi
243*699cd480SApple OSS Distributions
244*699cd480SApple OSS Distributionsexit 0
245